]> andersk Git - openssh.git/blobdiff - regress/multiplex.sh
- djm@cvs.openbsd.org 2010/01/09 05:04:24
[openssh.git] / regress / multiplex.sh
index 8605d5e0b0a6db993185d7bd58d3f075fde755b0..8a98a6e540264939e3d681d59adb69346b91dbc1 100644 (file)
@@ -1,40 +1,61 @@
-#      $OpenBSD: multiplex.sh,v 1.5 2004/06/17 06:19:06 dtucker Exp $
+#      $OpenBSD: multiplex.sh,v 1.12 2009/05/05 07:51:36 dtucker Exp $
 #      Placed in the Public Domain.
 
-CTL=$OBJ/ctl-sock
+CTL=/tmp/openssh.regress.ctl-sock.$$
 
 tid="connection multiplexing"
 
+if grep "#define.*DISABLE_FD_PASSING" ${BUILDDIR}/config.h >/dev/null 2>&1
+then
+       echo "skipped (not supported on this platform)"
+       exit 0
+fi
+
 DATA=/bin/ls${EXEEXT}
 COPY=$OBJ/ls.copy
+LOG=$TEST_SSH_LOGFILE
 
 start_sshd
 
 trace "start master, fork to background"
-${SSH} -2 -MS$CTL -F $OBJ/ssh_config -f somehost sleep 120
+${SSH} -Nn2 -MS$CTL -F $OBJ/ssh_config -oSendEnv="_XXX_TEST" somehost &
+MASTER_PID=$!
+
+# Wait for master to start and authenticate
+sleep 5
+
+verbose "test $tid: envpass"
+trace "env passing over multiplexed connection"
+_XXX_TEST=blah ${SSH} -F $OBJ/ssh_config -oSendEnv="_XXX_TEST" -S$CTL otherhost sh << 'EOF'
+       test X"$_XXX_TEST" = X"blah"
+EOF
+if [ $? -ne 0 ]; then
+       fail "environment not found"
+fi
 
+verbose "test $tid: transfer"
 rm -f ${COPY}
 trace "ssh transfer over multiplexed connection and check result"
-${SSH} -S$CTL otherhost cat ${DATA} > ${COPY}
+${SSH} -F $OBJ/ssh_config -S$CTL otherhost cat ${DATA} > ${COPY}
 test -f ${COPY}                        || fail "ssh -Sctl: failed copy ${DATA}" 
 cmp ${DATA} ${COPY}            || fail "ssh -Sctl: corrupted copy of ${DATA}"
 
 rm -f ${COPY}
 trace "ssh transfer over multiplexed connection and check result"
-${SSH} -S $CTL otherhost cat ${DATA} > ${COPY}
+${SSH} -F $OBJ/ssh_config -S $CTL otherhost cat ${DATA} > ${COPY}
 test -f ${COPY}                        || fail "ssh -S ctl: failed copy ${DATA}" 
 cmp ${DATA} ${COPY}            || fail "ssh -S ctl: corrupted copy of ${DATA}"
 
 rm -f ${COPY}
 trace "sftp transfer over multiplexed connection and check result"
 echo "get ${DATA} ${COPY}" | \
-       ${SFTP} -oControlPath=$CTL otherhost >/dev/null 2>&1
+       ${SFTP} -S ${SSH} -F $OBJ/ssh_config -oControlPath=$CTL otherhost >$LOG 2>&1
 test -f ${COPY}                        || fail "sftp: failed copy ${DATA}" 
 cmp ${DATA} ${COPY}            || fail "sftp: corrupted copy of ${DATA}"
 
 rm -f ${COPY}
 trace "scp transfer over multiplexed connection and check result"
-${SCP} -oControlPath=$CTL otherhost:${DATA} ${COPY} >/dev/null 2>&1
+${SCP} -S ${SSH} -F $OBJ/ssh_config -oControlPath=$CTL otherhost:${DATA} ${COPY} >$LOG 2>&1
 test -f ${COPY}                        || fail "scp: failed copy ${DATA}" 
 cmp ${DATA} ${COPY}            || fail "scp: corrupted copy of ${DATA}"
 
@@ -43,7 +64,7 @@ rm -f ${COPY}
 for s in 0 1 4 5 44; do
        trace "exit status $s over multiplexed connection"
        verbose "test $tid: status $s"
-       ${SSH} -S $CTL otherhost exit $s
+       ${SSH} -F $OBJ/ssh_config -S $CTL otherhost exit $s
        r=$?
        if [ $r -ne $s ]; then
                fail "exit code mismatch for protocol $p: $r != $s"
@@ -51,7 +72,7 @@ for s in 0 1 4 5 44; do
 
        # same with early close of stdout/err
        trace "exit status $s with early close over multiplexed connection"
-       ${SSH} -S $CTL -n otherhost \
+       ${SSH} -F $OBJ/ssh_config -S $CTL -n otherhost \
                 exec sh -c \'"sleep 2; exec > /dev/null 2>&1; sleep 3; exit $s"\'
        r=$?
        if [ $r -ne $s ]; then
@@ -59,6 +80,13 @@ for s in 0 1 4 5 44; do
        fi
 done
 
-# kill master, remove control socket.  ssh -MS will exit when sleep exits
-$SUDO kill `cat $PIDFILE`
-rm -f $CTL
+trace "test check command"
+${SSH} -F $OBJ/ssh_config -S $CTL -Ocheck otherhost || fail "check command failed" 
+
+trace "test exit command"
+${SSH} -F $OBJ/ssh_config -S $CTL -Oexit otherhost || fail "send exit command failed" 
+
+# Wait for master to exit
+sleep 2
+
+kill -0 $MASTER_PID >/dev/null 2>&1 && fail "exit command failed" 
This page took 0.104048 seconds and 4 git commands to generate.